#!/bin/sh
#
#  This script checks for all the files. 
#
#
#
. ~/.profile
# set -x

# set cycle

table=$1
yyyymmdd=$2
cycle=$3

data_dir="/pub/data/model/grid/grib/cmcens";
tmp_dir="$DBNROOT/tmp/$$"
mkdir $tmp_dir
current_time=`date -u +%H%M`;

# set up table of filenames from template

sed -e "s/YYYYMMDD/$yyyymmdd/" $table | sed -e "s/CC/$cycle/"  > $tmp_dir/file_list.$$ 

# check if we have all the files
echo ""
echo "Check for files that are still missing for cycle $cycle at $current_time..."
$DBNROOT/user/check_for_file_list.pl $tmp_dir/file_list.$$
status=$?
if [ $status -ne 0 ]
then
   echo "We are still missing some files. "
   rm -r $tmp_dir
   exit
else
   echo "We have all the files and are ready to process"
fi

rm -r $tmp_dir
exit $status
