#!/bin/sh

. ~/.profile
yyyymmdd=`date -u +%Y%m%d`
cycle=$1

GRIBMAP=/usr/local/bin/gribmap
WGRIB=/usr/local/bin/wgrib

subdir=sref${yyyymmdd}
old_ctl=/home/nomad1/nomadwww/apps/nomad/ncep_nomad/sref_

grid212dir=/var/www/grads
lasthr=87
n=`expr $lasthr / 3 + 1`

local_latest=$DATAROOT/sref/sref.$yyyymmdd/$cycle/pgrb
remote_latest=/pub/data/nccf/com/sref/prod/sref.$yyyymmdd/$cycle/pgrb

for model in eta rsm em nmm
do
   for ensmb in ctl1 ctl2 ctl n1 n2 n3 n4 p1 p2 p3 p4
   do
   
      if [ $model = 'eta' ]; then
        if [ $ensmb = 'ctl' ] ; then
           continue
         fi
      fi
      
      if [ $model = 'rsm' ]; then
        if [ $ensmb = 'ctl2' -o $ensmb = 'n3' -o $ensmb = 'n4' -o $ensmb = 'p3' -o $ensmb = 'p4' -o $ensmb = 'ctl' ] ; then
           continue
         fi
      fi
      
      if [ $model = 'em' -o $model = 'nmm' ]; then
        if [ $ensmb = 'ctl1' -o $ensmb = 'ctl2' -o $ensmb = 'n2' -o $ensmb = 'n3' -o $ensmb = 'n4' -o $ensmb = 'p2' -o $ensmb = 'p3' -o $ensmb = 'p4' ] ; then
           continue
         fi
      fi
      
      fcycle=00
      mkdir -p $local_latest 
      cd $local_latest 
      
      while [ $fcycle -le $lasthr ]
      do
      
         echo "fcycle=$fcycle"
         
         file=sref_${model}.t${cycle}z.pgrb212.${ensmb}.f${fcycle}
         
         $DBNROOT/user/get_missing_files.sh ftpprd.ncep.noaa.gov $remote_latest $file $local_latest MODEL SREF_PGB 
         
         fcycle=`expr $fcycle + 3`
         if [ $fcycle -lt 10 ]; then fcycle=0$fcycle; fi
         
      done

      cd $local_latest
      date=`$WGRIB -4yr sref_${model}.t${cycle}z.pgrb212.${ensmb}.f00 -d 1 -o /dev/null | cut -f3 -d: | cut -c3-10`
      
      yyyy="`echo $yyyymmdd | cut -c1-4`"
      mm="`echo $yyyymmdd | cut -c5-6`"
      dd="`echo $yyyymmdd | cut -c7-8`"
      echo "yyyy=$yyyy, mm=$mm, dd=$dd"
      
      case $mm in
         01) month=jan;;
         02) month=feb;;
         03) month=mar;;
         04) month=apr;;
         05) month=may;;
         06) month=jun;;
         07) month=jul;;
         08) month=aug;;
         09) month=sep;;
         10) month=oct;;
         11) month=nov;;
         12) month=dec;;
          *) echo "month error $mo"
             exit 1;;
      esac
      datestr="${cycle}Z$dd$month$yyyy"
      
      # make new ctl file
      
      date="`date -u +\"%b %d %H:%M UTC\"`"

      cd $local_latest
      
      
      # write control file
      sed <${old_ctl}${model}.ctl -e "s#(date)#$datestr#" -e "s#(dir)#^#" | \
        sed -e "s#(cdate)#$cdate#" -e "s/(cycle)/$cycle/" \
            -e 's=/export/sgi73/wd51we/grads/=='  -e "s#(ensmb)#$ensmb#" \
            -e "s/tdef *[0-9]* /tdef $n /" >$latest/sref_${model}_${ensmb}_${cycle}z.ctl
      [ $? -ne 0 ] && exit 8
      
      cd $local_latest
      
      $GRIBMAP -i $latest/sref_${model}_${ensmb}_${cycle}z.ctl
      #[ $? -ne 0 ] && exit 8
     
      # or is it this one? 
      #sed <${old_ctl}${model}.ctl -e "s#(date)#$date#" -e "s#(dir)#^#" | \
      #  sed -e "s#(cdate)#$cdate#" -e "s/(cycle)/$cycle/" \
      #      -e 's=/export/sgi73/wd51we/grads/=='  -e "s#(ensmb)#$ensmb#" | \
      #  sed -e "s=/global/save/nomad/grads=$grid212dir=" \
      #      -e "s/tdef *[0-9]* /tdef $n /" >$latest/sref_${model}_${ensmb}_${cycle}z.ctl
      # 
      # [ $? -ne 0 ] && exit 8
      
      
   #finish for loop for ensmb
   done
      
#finish for loop model
done
      
[ $? -ne 0 ] && exit 8
      
exit 0
