#!/bin/sh
. ~/.profile

set -x

gdsxml=`find /home/nomad1/nomadwww/apps/gds -follow -name "gds.xml" -print `
#gdsxmldir=/home/people/wd23ja/scripts
echo "gdsxml=$gdsxml"
gdsxmldir=`dirname $gdsxml`
out=${gdsxmldir}/outxml
oldlist=${gdsxmldir}/oldlist
newlist=${gdsxmldir}/newlist
acceptlist=${gdsxmldir}/acceptlist
includefl=${gdsxmldir}/include_dir
noincludefl=${gdsxmldir}/noinclude_dir
runhttp=${gdsxmldir}/../scripts/wwwgrab
echo "gdsxmldir=$gdsxmldir, oldlist=$oldlist, newlist=$newlist "

if [ ! -s $oldlist ]; then
   touch $oldlist
fi
rm $acceptlist $out
touch $acceptlist

alldir=`cat $includefl`
#alldir="/home/nomadwww/ncep_data"
alldir="/home/nomad1/nomadwww/ftpdata"
echo "alldir=$alldir"
noincld=`cat $noincludefl`
echo "noincld=$noincld"

find_dataset() {

#find the dataset
# check first level list
  alldirs11=`ls -l $1 | grep "^dr" | awk '{print $9}'`
  alldirs12=`cd $1; ls -l *.ctl | awk '{print $9}'`
  for dir1 in $alldirs11 $alldirs12
  do
     echo "**** in $dir1, $1/$dir1"
    if [ -d $1/$dir1 ]; then
     readable=`cd $1; ls -l | grep " $dir1\$" | cut -c8`
          if [ $dir1 = "eta" ]; then
             echo "dir1=$dir1, $readable"
          fi
     if [ "$readable" != "r" ] ; then continue; fi
     newline=`find $1/$dir1 -name "*.ctl" -print`
     testnewline=`echo $newline | cut -c1-2`
          if [ $dir1 = "eta" ]; then
             echo "dir1=$dir1, $testnewline"
          fi
     if [ "$testnewline" != "" ]; then
      echo >>$out "      <!-- $dir data  -->"
      echo >>$out "        <mapdir name=\"$dir1\">"
         find_dataset $1/$dir1 
      echo >>$out "        </mapdir>"
     fi
    fi

   checkctl=`echo $dir1 |sed s#.*\.ctl#ctl# `
   if [ "$checkctl" = "ctl" ]; then
     readable=`cd $1; ls -l $dir1 | cut -c8`
     if [ "$readable" != "r" ] ; then continue; fi
      checkfilein=`grep -c "$1/$dir1" $acceptlist`
      if [ $checkfilein -gt 0 ]; then
          dir1nm=`echo $dir1 |sed s#\.ctl## `
          echo >>$out "            <dataset name=\"$dir1nm\" "
          echo >>$out "                  file = \"$1/$dir1\""
          echo >>$out "                  format = \"ctl\"/>"
      fi
   fi
  done
   

#check file readable by world
}

set -x


#
# this section generates the data listings
#

### check if there is new .ctl files
find $alldir -name "*.ctl" -print >$newlist

diffflag=`diff -q $newlist $oldlist | cut -c1-2`
diffflag=${diffflag}null
echo "diffflag=$diffflag"

newlistfile=`cat $newlist`
for file in $newlistfile
do
   echo "file=$file"
   checkin="no"
   for nodir in $noincld
   do
      if [ "$nodir" != "" ]; then
        checkin=`echo $file | sed s#.*$nodir.*#yes# |cut -c1-3`
      fi
      if [ $checkin = "yes" ]; then
         break
      fi
   done
   if [ $checkin != "yes" ]; then
      echo $file >>$acceptlist
   fi
done


#change xml
if [ $diffflag != 'null' ]; then

#
# this is the header of the gds.xml file
#

  cat >$out <<EOF
<?xml version="1.0" encoding="ISO-8859-1"?>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
This is a configuration file for the GrADS-DODS Server.

See README and doc/index.html for general GDS information.

See doc/tag-ref.html for help editing this file.

If you want to revert your GDS to its "factory settings", overwrite
gds.xml with the file gds.xml.reference.
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->

<gds>

  <catalog temp_size_limit="1000">
    <data>
EOF
#
# write data set
#
  for maindir in $alldir
  do
    if [ -d $maindir ]; then
       find_dataset $maindir 
    fi
  done

#
# this is the tail section of the gds.xml file

cat >>$out <<EOF
    </data>

  </catalog>

  <log level="info" mode="rotate" frequency="month" file="log/gds.log" 
print_module="true" >
  </log>

  <grads>

     <invoker grads_dir="/usr/local/bin" time_limit="480"/>
     <!-- edit this tag to point to your GrADS distribution -->

  </grads>


  <servlet>

    <filter-abuse enabled="false" hits="10000" timeout="2" />
    <filter-overload enabled="false" limit="20" />
    <!-- edit these tags to enable 'throttling' features  -->

    <filter-analysis enabled="true" />

  </servlet>


  <mapper>

    <service-admin enabled="true" auth="jordan" /> 
    <!-- edit this tag to enable the administration service -->

  </mapper>


  <privilege_mgr default="public"> 

    <ip_range mask="127.0.0.1" privilege="private" />

    <privilege name="public"> 
    <!-- edit this tag to control public access -->
      <deny path="private" />
    </privilege>

    <privilege name="private" /> <!-- no deny tags, allows full access -->

    <!-- specify more privilege sets and IP range assignments here -->

  </privilege_mgr>

</gds>
EOF

rm $gdsxml
cp $out $gdsxml

# submit new gds.xml
    $runhttp "http://localhost:9090/dods/admin?auth=jordan&cmd=reload"

#    if [ $? -ne 0 ]; then 
#      echo "$crtday $hh gds.xml is not reload" 
#    fi

cp $newlist $oldlist

#end change xml (if)

fi


exit 0
